# grafické objekty v tkinter

import tkinter                                                              # vytvorí premennú "tkinter", pomocou ktorej budeme mať prístup (bodkovou notáciou) k funkciám v module

obrazok = tkinter.Canvas(bg='white')                                        # vytvorí plátno grafickej aplikácie a priradíme ho do premennej "obrazok"
                                                                            # vzniká malá grafická aplikácia (malé okno) a aj plátno, ktoré sa ale zatiaľ v tejto aplikácii nenachádza

obrazok.pack()                                                              # umiestni naše plátno do grafickej aplikácie (do okna) 



##tkinter.mainloop()                                                        # grafická aplikácia, vďaka ktorej v operačnom systéme reaguje na klikanie, presúvanie, zmenu veľkost atď.
                                                                            # pri spustení pod IDLE nie je tento príkaz potrebný


# vlastnosti plátna: bod (0,0) je presunutý do ľavého horného rohu plátna, kde x-ová os prechádza zľava doprava po hornej hrane plátna a
                    # y-ová os prechádza zhora nadol po ľavej hrane plátna po vytvorení plátna sú rozmery 379x265 pixelov                                                                        


# vkladanie a úprava textu


obrazok.create_text(150, 130, text='center', font='arial 15')               # príkaz "create_text" umiestni zadaný text 'center', kde súradnice x a y určujú polohu stredu textu
                                                                            # voliteľným parametrom "font" meníme štýl a veľkosť písma, ale meno písma sa musí skladať len z jedného slova
obrazok.create_text(50, 130, text='left',font='times 10')                       
obrazok.create_text(250, 130, text='right',font='courier 10')
obrazok.create_text(150, 180, text='down',font='impact 10')
obrazok.create_text(150, 80, text='up', font='calibri 10')


obrazok.create_text(150, 130, text='center', font='arial 15', fill='red')   # voliteľným parametrom "fill" meníme farbu textu
obrazok.create_text(50, 130, text='left',font='times 10', angle='90')       # voliteľným parametrom "angle" meníme uhol otočenia proti smeru hod. ručičiek             
obrazok.create_text(250, 130, text='right',font='courier 10',angle='-90')   # voliteľným parametrom "angle" meníme uhol otočenia v smere hod. ručičiek
obrazok.create_text(150, 180, text='down',font='impact 10')
obrazok.create_text(150, 80, text='up', font='calibri 10')


# vkladanie geometrických objektov


obrazok.create_rectangle(50, 80, 250, 180, outline='red')                   # príkaz "create_rectangle" umiestni obdĺžnik,
                                                                            # kde uvádzame súradnice dvoch protiľahlých vrcholov tohto obdĺžnika
                                                                            # voliteľným parametrom "outline" nastavíme farbu obrysu
obrazok.create_rectangle(30, 60, 280, 200, outline='blue',width=1)          # voliteľným parametrom "width" nastavíme hrúbku obrysu
obrazok.create_rectangle(70, 100, 230, 160, outline='yellow',fill='green')  # voliteľným parametrom "fill" nastavíme farbu výplne


x1=20                                                                       # je vhodné pracovať s premennými, v ktorých máme uložené napr. súradnice nejakých bodov
y1=50                                                                       # alebo veľkosti útvarov
s,v=270,160
obrazok.create_rectangle(x1, y1, x1+s, y1+v, outline='gray', width=2)


# RGB model a miešanie farieb


farba1 ='#60ce40'                                                           # pri kreslení v tkinter môžeme zadávať vlastné farby menami
                                                                            # zakódujeme ich RGB-trojicu do šestnástkovej sústavy ako 3 dvojciferné čísla (spolu 6 cifier)


r,g,b=200,90,50
farba2=f'#{r:02x}{g:02x}{b:02x}'                                            # formátovací reťazec, ktorý dokáže previesť číslo do 16-ovej sústavy

                                                                            
obrazok.create_oval(30, 60, 280, 200, outline=farba2)                       # príkaz "create_oval" umiestni elipsu cez "neviditeľný“ obdĺžnik, do ktorého bude táto elipsa vpísaná
                                                                            # elipsa umiestená do "neviditeľného" štvorca nám dáva kružnicu
                                                                            

obrazok.create_line(350, 100, 350, 200, fill='green')                       # príkaz "create_line" umiestni úsečku, kde uvádzame dve dvojice súradníc
obrazok.create_line(350, 100, 330, 150, 350, 200, fill='yellow')            # príkaz "create_line" umiestni lomenú čiaru, kde uvádzame postupne dvojice súradníc
a=(330,100)                                                                 # vhodné je si vopred definovať dvojice súradníc
b=(310,150)
c=(330,200)
obrazok.create_line(a, b, c, width=2.5)



# vkladanie obrázkov


##obr = tkinter.PhotoImage(file='korytnacka.png')                           # na nakreslenie nejakého obrázku musíme najprv vytvoriť obrázkový objekt pomocou tkinter.PhotoImage()
##obrazok.create_image(330, 240, image=obr)                                 # ten následne uvedieme ako parameter do príkazu na kreslenie obrázkov na grafickú plochu
                                                                            # príkaz "create_image"  umiestni obrázkový objekt obr, kde súradnice x a y určujú polohu stredu obrázku
                                                                            # štandardný podporovaný formát obrázkov je png alebo gif
                                                                            # pre zmenu vykresľovaných obrázkov je potrebné využiť knižničný modul PIL, t.j. Python Imaging Library 

##tkinter.mainloop()                                                        # grafická aplikácia, vďaka ktorej v operačnom systéme reaguje na klikanie, presúvanie, zmenu veľkost atď.
                                                                            # pri spustení pod IDLE nie je tento príkaz potrebný
