# udalosti, ktoré vznikajú v bežiacej grafickej aplikácii spôsobené aktivitami operačného systému (tikanie časovača)

import tkinter
import random


obrazok1 = tkinter.Canvas(bg='white', width=700, height=800)                                        # "bg"-nastavenie farby pozadia, "width"-šírka, "height"-výška
obrazok1.pack()


d = 50  
x0, y0 = 100, 50          
def casovac1():                                                                                     # metóda grafickej plochy "after()", ktorá pozdrží výpočet o nejaký počet milisekúnd 
    for y in range(y0, 200, d):
       for x in range(x0, 600, d):
         r = random.randrange(256)
         g = random.randrange(256)
         b = random.randrange(256)
         farba = f'#{r:02x}{g:02x}{b:02x}'
         obrazok1.create_oval(x, y, x+d, y+d, fill=farba)
    obrazok1.after(1000, casovac1)                                                                  # metóda "after()" môže byť zavolaná aj s druhým parametrom nejakej funkcie
                                                                                                    # v takomto prípade metóda výpočet sa naozaj nepozdrží,
                                                                                                    # ale pozdrží sa vyvolanie volanej funkcie definovanej bez parametrov
casovac1()



xx0, yy0 = 100, 300  
for y in range(yy0, 450, d):
     for x in range(xx0, 600, d):
         r = random.randrange(256)
         g = random.randrange(256)
         b = random.randrange(256)
         farba = f'#{r:02x}{g:02x}{b:02x}'
         obrazok1.create_oval(x, y, x+d, y+d, fill=farba)
         obrazok1.after(100)                                                                        # metóda "after()" len s jedným parametrom času v milisekundách
                                                                                                    # ak je súčasťou cyklov, tak po každom vykreslení kruhu pozdrží vykreslenie nového kruhu
                                                                                                    # ak nie je súčasťou cyklov, tak na začiatku pozdrží celkové vykreslenie kruhov



def casovac2():                                 
         r = random.randrange(256)
         g = random.randrange(256)
         b = random.randrange(256)
         farba = f'#{r:02x}{g:02x}{b:02x}'
         x=random.randrange(10)
         y=random.randrange(3)
         obrazok1.create_oval(d*x+100, d*y+550, d*x+d+100, d*y+d+550, fill=farba)
         obrazok1.after(2000, casovac2)                                                           

casovac2()                                                                                          # "casovac2()" náhodne generuje a vykresľuje kruhy na zvolených pozíciách
                                                                                                    # nakreslený kruh pri následnom generovanom vykresľovaní zostáva vykreslený





def casovac3():
         obrazok1.delete(id1)                                                                       # zavedený identifikátor "id1" je lokálny
         r = random.randrange(256)
         g = random.randrange(256)
         b = random.randrange(256)
         farba = f'#{r:02x}{g:02x}{b:02x}'
         x=random.randrange(10)
         y=random.randrange(3)
         id1=obrazok1.create_oval(d*x+100, d*y+550, d*x+d+100, d*y+d+550, fill=farba)
         obrazok1.after(2000, casovac3)
   
casovac3()





def casovac4():  
         obrazok1.delete('all')                                                                     # funkcia "delete" s reťazcom 'all' zakaždým premaže celé vykresľovacie plátno
         r = random.randrange(256)
         g = random.randrange(256)
         b = random.randrange(256)
         farba = f'#{r:02x}{g:02x}{b:02x}'
         x=random.randrange(10)
         y=random.randrange(3)
         id1=obrazok1.create_oval(d*x+100, d*y+550, d*x+d+100, d*y+d+550, fill=farba)
         obrazok1.after(2000, casovac4)
   
casovac4()






def casovac5(): 
         obrazok1.delete('kruh')                                                                     # pre štítok "kruh" nerozlišujeme lokálnosť
         r = random.randrange(256)
         g = random.randrange(256)
         b = random.randrange(256)
         farba = f'#{r:02x}{g:02x}{b:02x}'
         x=random.randrange(10)
         y=random.randrange(3)
         obrazok1.create_oval(d*x+100, d*y+550, d*x+d+100, d*y+d+550, fill=farba, tag='kruh')
         obrazok1.after(2000, casovac5)
   
casovac5()






##tkinter.mainloop()                                                              # grafická aplikácia, vďaka ktorej v operačnom systéme reaguje na klikanie, presúvanie, zmenu veľkost atď.
                                                                                  # pri spustení pod IDLE nie je tento príkaz potrebný
