# zmeny udalosti dvoch pohybujúcich sa grafických objektov

import tkinter

obrazok3 = tkinter.Canvas(bg='white', width=600, height=650)     # "bg"-nastavenie farby pozadia, "width"-šírka, "height"-výška
obrazok3.pack()

turtle = tkinter.PhotoImage(file='korytnacka.png')               # na nakreslenie nejakého obrázku musíme najprv vytvoriť obrázkový objekt pomocou tkinter.PhotoImage()
snail = tkinter.PhotoImage(file='slimak.png') 

obrazok3.create_image(500, 100, image=turtle)                    # príkaz "create_image"  umiestni obrázkový objekt, kde súradnice x a y určujú polohu stredu obrázku                  
obrazok3.create_image(100, 100, image=snail)



# spoločný pohyb oproti sebe

turtle2 = obrazok3.create_image(550, 200, image=turtle)
snail2 = obrazok3.create_image(50, 200, image=snail)

def pohyb2():
    obrazok3.move(turtle2, -2, 0)
    obrazok3.move(snail2, 1, 0)
    obrazok3.after(100, pohyb2)

pohyb2()

# zmena parametra času a zastavovanie pomocou časovačov 

turtle3 = obrazok3.create_image(550, 300, image=turtle)
snail3 = obrazok3.create_image(50, 300, image=snail)
cas3_1=100
cas3_2=100
def pohyb3_1():
    obrazok3.move(turtle3, -2, 0)
    if lozi3:
        obrazok3.after(cas3_1, pohyb3_1)

def pohyb3_2():
    obrazok3.move(snail3, 1, 0)
    if plazi3:
        obrazok3.after(cas3_2, pohyb3_2)

plazi3= lozi3= True          
pohyb3_1()
pohyb3_2()



# aby sa grafické objekty nerozbehli hneď pri štarte programu

turtle4 = obrazok3.create_image(550, 400, image=turtle)
snail4 = obrazok3.create_image(50, 400, image=snail)
cas4_1=100
cas4_2=100                                                                                 
def start(event):                                                                      # vytvárame vlastnú funkciu "start(...)", ktorú zviažeme s udalosťou kliknutia
                                                                                       # volaná funkcia "start(...)" musí mať jeden formálny parameter napr. event
    obrazok3.unbind('<Button-1>')                                                      # metóda "unbind(...)", pomocou ktorej vieme zrušiť zviazanie príslušnej udalosti
    obrazok3.unbind_all('s')                                                           # zruší klikaciu udalosť ľavého tlačidla myšky  
    pohyb4_1()                                                                         # zruší klikaciu udalosť klávesu 's' 
    pohyb4_2()
    
def pohyb4_1():
    obrazok3.move(turtle4, -2, 0)
    if lozi4:
        obrazok3.after(cas4_1, pohyb4_1)

def pohyb4_2():
    obrazok3.move(snail4, 1, 0)
    if plazi4:
        obrazok3.after(cas4_2, pohyb4_2)
        

plazi4=lozi4=True
obrazok3.bind('<Button-1>', start)                                                     # kliknutie (zatlačenie tlačidla myši) pre reťazec '<Button-x>', kde x je 1, 2 alebo 3 
                                                                                       # 1 označuje ľavé tlačidlo myši, 2 označuje stredné tlačidlo (koliesko), 3 označuje pravé tlačidlo
                                                                                       # druhý parameter metódy "bind(...,...)" musí byť referencia na funkciu, ktorá má jeden parameter
                                                                                       # no voláme ju bez parametra t.j. bez zátvoriek 
                                                                                     
obrazok3.bind_all('s', start)                                                          # každé zatlačenie nejakého klávesu na klávesnici môže vyvolať udalosť
                                                                                       # základnou univerzálnou udalosťou je '<Key>', ktorá sa vyvolá pri každom zatlačení nejakého klávesu



                                                                                     

# reakcia grafického objektu pri dosiahnutí konkrétnej pozície a využitie súradníc kliknutého bodu v grafickej ploche

snail5 = obrazok3.create_image(50, 500, image=snail)
turtle5 = obrazok3.create_image(550, 500, image=turtle)
cas5_1=100
cas5_2=100
def start5(kurzor):                                                                    
    obrazok3.unbind_all('<Up>')
    pohyb5_1()
    pohyb5_2()
   
def pohyb5_1():
    obrazok3.move(turtle5, -2, 0)
    if lozi5:
        obrazok3.after(cas5_1, pohyb5_1)

def pohyb5_2():
    if obrazok3.coords(turtle5)[0]<obrazok3.coords(snail5)[0]+60:
        obrazok3.create_text(obrazok3.coords(snail5)[0]+20, obrazok3.coords(snail5)[1]-40, text='Ups!', fill='red', font='arial 10 bold')
    elif plazi5:
        obrazok3.move(snail5, 1, 0)
        obrazok3.after(cas5_2, pohyb5_2)

cas5_1=100
cas5_2=100
plazi5=lozi5=True
obrazok3.bind_all('<Up>', start5)




# grafický objekt sa znova pohne

snail6 = obrazok3.create_image(50, 600, image=snail)
turtle6 = obrazok3.create_image(550, 600, image=turtle)

def start6(kurzor):                                                                    
    obrazok3.unbind_all('<Down>')
    pohyb6_1()
    pohyb6_2()

def snailmoze(event):                            # globálne premenné môžeme používať vo vnútri funkcii len dovtedy kým ich nemeníme
                                                 # priraďovací príkaz vo funkcii totiž znamená, že vytvárame novú lokálnu premennú
    global plazi6                                # Python vo vnútri funkcie do premennej "plazi6"  priraďuje nejakú hodnotu a stáva sa v nej lokálnou
    plazi6=False
    
def snailnemoze(event):                                                                    
    global plazi6                                # ak chceme pracovať vo funkcii s globálnou premennou, použijeme príkaz "global"
    plazi6=True                                  # nechceme aby ju Python vytvoril aj v lokálnom mennom priestore, ale ponechal len v globálnom
    pohyb6_2()

def turtlemoze(event):                                                                    
    global lozi6
    lozi6=False
    
def turtlenemoze(event):                                                                    
    global lozi6
    lozi6=True
    pohyb6_1()
   
def pohyb6_1():
    obrazok3.move(turtle6, -2, 0)
    if lozi6:
        obrazok3.after(cas6_1, pohyb6_1)

def pohyb6_2():
    if obrazok3.coords(snail6)[0]<obrazok3.coords(turtle6)[0]<obrazok3.coords(snail6)[0]+60:
        obrazok3.create_text(obrazok3.coords(snail6)[0]+20, obrazok3.coords(snail6)[1]-40, text='Ups!', fill='red', font='arial 10 bold',tag='ups')
    elif plazi6:
        obrazok3.delete('ups')
        obrazok3.move(snail6, 1, 0)
        obrazok3.after(cas6_2, pohyb6_2)

plazi6=lozi6=True
cas6_1=100
cas6_2=100
obrazok3.bind_all('<Down>', start6)
obrazok3.bind_all('g', snailmoze)
obrazok3.bind_all('h', snailnemoze)
obrazok3.bind_all('j', turtlemoze)
obrazok3.bind_all('k', turtlenemoze)





#obrazok3.create_oval(kurzor.x-5, kurzor.y-5, kurzor.x+5, kurzor.y+5, fill='red')  # využijeme súradnice kliknutého bodu v grafickej ploche  
